# Fonctionne uniquement avec python3

# Le code souscrit au topic "sensor/humidity"
# chaque fois qu'un message est reçut, la valeur est placée dans une liste
# cette liste est affichée dans un graphe

import paho.mqtt.client as mqtt
import matplotlib.pyplot as plt
import matplotlib.animation as animation
import numpy as np

plt.ion()

listeH = [0] * 60
listeL = [0] * 60
limiteH = [300] * 60
limiteL = [600] * 60
ax1=plt.axes() 

# make plot
plt.subplot(211)
line, = plt.plot(listeH)
line2, = plt.plot(limiteH, 'r--')
plt.ylim([100,600])
plt.xlabel('Temps (secondes)')
plt.ylabel('Humidité')

plt.subplot(212)
line3, = plt.plot(listeL)
line4, = plt.plot(limiteL, 'r--')
plt.ylim([100,1600])
plt.xlabel('Temps (secondes)')
plt.ylabel('Luminosité')

# The callback for when the client receives a CONNACK response from the server.
def on_connect(client, userdata, rc):
	print("Connected with result code "+str(rc))
# Subscribing in on_connect() means that if we lose the connection and
# reconnect then subscriptions will be renewed.
	client.subscribe("sensor/moisture")
	client.subscribe("sensor/lum")


def on_message_moisture(client, userdata, msg):
	print ("Topic:", msg.topic+ '\n Message: '+str(msg.payload))

	#on ajoute une donnée dans la liste
	listeH.append(float(msg.payload))
	del listeH[0]
	line.set_xdata(np.arange(len(listeH)))

	line2.set_xdata(np.arange(len(limiteH)))

	# update la liste
	line.set_ydata(listeH)
	# update le plot
	plt.draw()

def on_message_lum(client, userdata, msg):
	print ("Topic:", msg.topic+ '\n Message: '+str(msg.payload))

	#on ajoute une donnée dans la liste
	listeL.append(float(msg.payload))
	del listeL[0]
	line3.set_xdata(np.arange(len(listeL)))

	line4.set_xdata(np.arange(len(limiteL)))

	# update la liste
	line3.set_ydata(listeL)  
	# update le plot
	plt.draw()

	
client = mqtt.Client()
client.on_connect = on_connect
client.message_callback_add("sensor/moisture", on_message_moisture)
client.message_callback_add("sensor/lum", on_message_lum)
#client.on_message = on_message

client.connect("debian", 1883, 60)

client.loop_forever()